// Keep these lines for a best effort IntelliSense of Visual Studio 2017 and higher.
/// <reference path="./../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.758.8/runtimes/native1.12-tchmi/TcHmi.d.ts" />

/*
 * Generated 2023/4/10 14:28:26
 * Copyright (C) 2023
 */
var TcHmi;
(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    let Controls;
    (function (/** @type {globalThis.TcHmi.Controls} */ Controls) {
        let FrameworkPrjEmpty1;
        (function (FrameworkPrjEmpty1) {
            class ToggleStateControl extends TcHmi.Controls.System.TcHmiControl {
                /*
                Attribute philosophy
                --------------------
                - Local variables are not set while definition in class, so they have the value 'undefined'.
                - On compile the Framework sets the value from HTML or from theme (possibly 'null') via normal setters.
                - The "changed detection" in the setter will result in processing the value only once while compile.
                - Attention: If we have a Server Binding on an Attribute the setter will be called once with null to initialize and later with the correct value.
                */
                /**
                 * Constructor of the control
                 * @param {JQuery} element Element from HTML (internal, do not use)
                 * @param {JQuery} pcElement precompiled Element (internal, do not use)
                 * @param {TcHmi.Controls.ControlAttributeList} attrs Attributes defined in HTML in a special format (internal, do not use)
                 * @returns {void}
                 */
                constructor(element, pcElement, attrs) {
                    /** Call base class constructor */
                    super(element, pcElement, attrs);
                    /** Attribute variables are initialized with undefined. The System will call the setter later. See "Attribute philosophy" above. */
                    this.__machineState = undefined;
                    this.__showToggleStateButton = undefined;

                    /** Internal member variables */
                    this.__states = ["Start", "Stop", "Reset"];
                }
                /**
                  * If raised, the control object exists in control cache and constructor of each inheritation level was called.
                  * Call attribute processor functions here to initialize default values!
                  */
                __previnit() {
                    // Fetch template root element
                    this.__elementTemplateRoot = this.__element.find('.TcHmi_Controls_FrameworkPrjEmpty1_ToggleStateControl-Template');
                    if (this.__elementTemplateRoot.length === 0) {
                        throw new Error('Invalid Template.html');
                    }
                    // get the container for the state images
                    this.__elementImageContainer = this.__elementTemplateRoot.find('.tchmi-framework-control-js-sample-image-container');
                    // get the state image
                    this.__elementImage = this.__elementImageContainer.find('.tchmi-framework-control-js-sample-image');
                    // get the toggle state button
                    this.__elementToggleStateButton = this.__elementTemplateRoot.find('.tchmi-framework-control-js-sample-toggle-state-button');
                    // Call __previnit of base class
                    super.__previnit();
                }
                /**
                 * Is called during control initialize phase after attribute setter have been called based on it's default or initial html dom values.
                 * @returns {void}
                 */
                __init() {
                    super.__init();
                }
                /**
                * Is called by the system after the control instance gets part of the current DOM.
                * Is only allowed to be called from the framework itself!
                */
                __attach() {
                    super.__attach();
                    /**
                     * Initialize everything which is only available while the control is part of the active dom.
                     */
                    this.__processShowToggleStateButton();

                }
                /**
                * Is called by the system after the control instance is no longer part of the current DOM.
                * Is only allowed to be called from the framework itself!
                */
                __detach() {
                    super.__detach();
                    /**
                     * Disable everything which is not needed while the control is not part of the active dom.
                     * No need to listen to events for example!
                     */
                }
                /**
                * Destroy the current control instance.
                * Will be called automatically if system destroys control!
                */
                destroy() {
                    /**
                    * While __keepAlive is set to true control must not be destroyed.
                    */
                    if (this.__keepAlive) {
                        return;
                    }
                    super.destroy();
                    /**
                    * Free resources like child controls etc.
                    */
                }
                /**
                    * @description Setter function for 'data-tchmi-machine-state' attribute.
                    * @param {MachineStates} valueNew the new value or null: the value is a string of the enum MachineStates          
                    * @returns {void}
                    */
                 setMachineState = function (valueNew) {
                    /**
                    * MachineState is a string that is included in an enumeration.
                    * Custom datatypes are defined in a JSON schema at Schema\TypeDefinitions.
                    * If you define complex datatypes as objects, convert the value toObject.
                    */
                    var convertedValue = TcHmi.ValueConverter.toString(valueNew);
                    if (convertedValue === null) {
                        // If we have no value to set we have to fall back to the defaultValueInternal from JSON
                        convertedValue = this.getAttributeDefaultValueInternal('MachineState');
                    }
                    if (convertedValue === this.__machineState) {
                        // Skip processing when the value has not changed
                        return;
                    }
                    // Remember the new value
                    this.__machineState = convertedValue;

                    // Inform the system that the function has a changed result.
                    TcHmi.EventProvider.raise(this.__id + ".onFunctionResultChanged", ["getMachineState"]);
                    this.__processMachineState();
                };
                    /**
                    * @description Getter function for 'data-tchmi-machine-state' attribute.
                    * @returns {String}
                    */
                   getMachineState = function () {
                    return this.__machineState;
                };
                    /**
                    * @description Processor function for 'data-tchmi-machine-state' attribute.
                    * @returns {void}
                    */
                    __processMachineState = function () {
                    /** Process actions with MachineState */

                    // remove old machine state
                    this.__elementImage.removeClass();

                    // Check the new value of MachineState
                    if (this.__machineState.localeCompare("Start") === 0) {
                        /**
                        * Machine state was set to Start.
                        * Process Start.
                        */

                        // add new state icon
                        this.__elementImage.addClass('tchmi-framework-control-js-sample-state-start');
                    }
                    else if (this.__machineState.localeCompare("Stop") === 0) {
                        /**
                        * Machine state was set to Stop.
                        * Process Stop.
                        */

                        // add new state icon
                        this.__elementImage.addClass('tchmi-framework-control-js-sample-state-stop');
                    }
                    else if (this.__machineState.localeCompare("Reset") === 0) {
                        /**
                        * Machine state was set to Reset.
                        * Process Reset.
                        */

                        // add new state icon
                        this.__elementImage.addClass('tchmi-framework-control-js-sample-state-reset');
                    }
                    };
                    /**
                    * @description Setter function for 'data-tchmi-show-toggle-state-button' attribute.
                    * @param {boolean} valueNew the new value or null
                    * @returns {void}
                    */
                    setShowToggleStateButton = function (valueNew) {
                    var convertedValue = TcHmi.ValueConverter.toBoolean(valueNew);
                    if (convertedValue === null) {
                        // If we have no value to set we have to fall back to the defaultValueInternal from JSON
                        convertedValue = this.getAttributeDefaultValueInternal('ShowToggleStateButton');
                    }
                    if (convertedValue === this.__showToggleStateButton) {
                        // Skip processing when the value has not changed
                        return;
                    }
                    // Remember the new value
                    this.__showToggleStateButton = convertedValue;

                    // Inform the system that the function has a changed result.
                    TcHmi.EventProvider.raise(this.__id + ".onFunctionResultChanged", ["getShowToggleStateButton"]);
                    this.__processShowToggleStateButton();
                };
                    /**
                    * @description Getter function for 'data-tchmi-show-toggle-state-button' attribute.
                    * @returns {boolean}
                    */
                    getShowToggleStateButton = function () {
                    return this.__showToggleStateButton;
                };
                    /**
                    * @description Processor function for 'data-tchmi-show-toggle-state-button' attribute.
                    * @returns {void}
                    */
                    __processShowToggleStateButton = function () {
                    // hide or show the toggle state button

                    if (this.__showToggleStateButton) {
                        // show the state change button in the control
                        this.__elementToggleStateButton.removeClass('hide');
                        this.__elementToggleStateButton.addClass('visible');
                    }
                    else {
                        // hide the state change button in the control
                        this.__elementToggleStateButton.removeClass('visible');
                        this.__elementToggleStateButton.addClass('hide');
                    }

                    /**
                    * name: CheckAccess
                    * description: The functions checks the configurated access right of a control.
                    * param: {controlType} control The control to check.
                    * param: {string} requestedAccessright Name of the access right.
                    * returns: {boolean} True -> Control (user) has the right at the moment
                    * returns: {boolean} False -> Control (user) has not the right at the moment
                    * returns: {boolean} Null -> The access right cannot be determined at the moment
                    */

                    // check user access of "allowStateChange" that is defined in the description.json
                    if (TcHmi.Access.checkAccess(this, 'allowStateChange') === true) {
                        // Current logged in user has the rights to do this.

                        // allow the user to change the states
                        this.__elementToggleStateButton.removeClass('disabled');
                        this.__elementToggleStateButton.addClass('activate');

                        // save the current instance of the control for the click event
                        let $this = this;

                        // register onClick jquery event
                        // this code is called several times so unregister jquery event before register the event again
                        this.__elementToggleStateButton.off('click').on("click", function () {
                            // inside the click event this is the __elementToggleStateButton
                            // use the stored control instance $this to get the reference to the control instance
                            $this.__nextState();
                        });

                    } else {
                        // Current user has no rights to do this.

                        // disable autorun button
                        this.__elementToggleStateButton.removeClass('activate');
                        this.__elementToggleStateButton.addClass('disabled');
                    }
                };
                    /**
                    * @description This is the call of the api function 'toggleState'. Implement your code here.
                    * @returns {void}
                    */
                    toggleState = function () {
                    /**
                    * toggleState is defined in the description.json and called from outside.
                    * The api functions are shown in the graphical user interface of the enginnering in the twincat     
                    */

                    // switch to next state
                    this.__nextState();
                };
                    /**
                    * @description This is the call of the api function 'toggleToState'. Implement your code here.
                    * @param {Number} newState the state the icon shoud switch to
                    * @returns {Boolean} returns true if the state changed, otherwise false
                    */
                    toggleToState = function (newState) {
                    /**
                    * toggleToState is defined in the description.json and called from outside.
                    * The api functions are shown in the graphical user interface of the enginnering in the twincat hmi.                        
                    */

                    // convert the parameter and check if the value is valid
                    var convertedParameter = TcHmi.ValueConverter.toNumber(newState);
                    if (convertedParameter === null) {
                        // parameter is null: define what to do in this case  

                        // exit function call with failure 
                        return false;
                    }
                    else {
                        /**
                        * Parameter is a number.
                        * Process the action with the parameter.
                        */

                        // check if the parameter is in the range
                        if (newState < 0 || newState > 2) {
                            // newParameter is out of range

                            // exit function call with failure 
                            return false;
                        }

                        // check user access of "allowStateChange" that is defined in the description.json
                        if (TcHmi.Access.checkAccess(this, 'allowStateChange') === true) {
                            // current user has the rights to do this.

                            // set the machine state to the parameter state
                            this.setMachineState(this.__states[newState]);

                            // raise .onStateChanged event
                            TcHmi.EventProvider.raise(this.__id + '.onStateChanged');
                        }
                        else {
                            // current user is not allowed to do this

                            // exit function call with failure 
                            return false;
                        }
                    }

                    // exit function call with success
                    return true;
                };
                    /**
                    * @description This function is an internal function to change the current machine state.
                    * @returns {void}
                    */
                    __nextState = function () {
                    // check user access of "allowStateChange" that is defined in the description.json
                    if (TcHmi.Access.checkAccess(this, 'allowStateChange') === true) {
                        // current logged in user has the rights to do this.                              

                        // get the current machine state
                        var startIndex = this.__states.indexOf(this.getMachineState());

                        // get the next machine state
                        if (startIndex === this.__states.length - 1) {
                            // maximum value reached
                            startIndex = 0;
                        }
                        else {
                            // count up
                            startIndex++;
                        }

                        // switch into the next machine state
                        this.setMachineState(this.__states[startIndex]);

                        /*** Example: Raise event that is defined in the description.json ***/
                        /*
                        * Raise "onStateChanged" event that is defined in the description.json
                        * Important: this.__id is required to assign the raised event to the current control instance.                      
                        */

                        // raise .onStateChanged event
                        TcHmi.EventProvider.raise(this.__id + '.onStateChanged');
                    } else {
                        // Current user has no rights to do this.

                        // inform the system
                        console.log("User is not allowed to do this");
                    }
                };  
            }
            FrameworkPrjEmpty1.ToggleStateControl = ToggleStateControl;
        })(FrameworkPrjEmpty1 = Controls.FrameworkPrjEmpty1 || (Controls.FrameworkPrjEmpty1 = {}));
    })(Controls = TcHmi.Controls || (TcHmi.Controls = {}));
})(TcHmi || (TcHmi = {}));
/**
* Register Control
*/
TcHmi.Controls.registerEx('ToggleStateControl', 'TcHmi.Controls.FrameworkPrjEmpty1', TcHmi.Controls.FrameworkPrjEmpty1.ToggleStateControl);
